#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Copyright (c) 2013, a
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
# * Redistributions of source code must retain the above copyright notice, 
#   this list of conditions and the following disclaimer.
# * Redistributions in binary form must reproduce the above copyright notice, 
#   this list of conditions and the following disclaimer in the documentation 
#   and/or other materials provided with the distribution.
# * Neither the name of the <organization> nor the　names of its contributors 
#   may be used to endorse or promote products derived from this software 
#   without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL <COPYRIGHT HOLDER> BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys
sys.path.append('.')

from MQEasy00 import EFace
import copy

cEnd = 0

def Bunri1Vertex(vi, o, tf):
  f = EFace()
  f.load(tf, o)
  f.rotateSpecial(vi, 0)
  v1 = o.vertex[f.index[0]]
  f.index[0] = o.addVertex(v1.getPos())
  f.replaceNew()
  return

def BunriVertex(v, o):
  global cEnd
  if v.ref==0:
    return
  vi = o.getVertexIndexFromUniqueID(v.id)
  
  while len(v.faces)>1:
    faceBunri = o.face[v.faces[1]]
    Bunri1Vertex(vi, o, faceBunri)
  
  v.select = 0
  cEnd+=1

doc = MQSystem.getDocument()

for o in doc.object:
  for v in o.vertex:
    if v.select == 1:
      BunriVertex(v, o)

MQSystem.println("処琁E点数: "+str(cEnd))